/*****************************************************************************
* Sistemas Integrados TECNISA                                                *
*                                                                            *
* Compras e Suprimentos                                                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Nome: MENSAL_PROX_DATA_ENTREGA                                             *
*                                                                            *
* Descrio:                                                                 *
* Calcula datas de entrega da proxima entrega                                *
*                                                                            *
*                                                                            *
* Criao:                                                                   *
* 03/01/2000 - Yoris L. de Souza                                             *
*                                                                            *
* Manutenes:                                                               *
*   /  /   -                                                                 *
*                                                                            *
*                                                                            *
******************************************************************************

******************************************************************************
* PARAMETROS:                                                                *
*                                                                            *
* P_CDFILIAL     - Cdigo da Filial                                          *
* P_CDPERIENTR   - Cdigo da Periodicidade de Entrega                        *
* P_DTINICIAL    - Data do Inicio do Mes                                     *
* P_IDDIANUTIL   - Considera dia nao util                                    *
******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'MENSAL_PROX_DATA_ENTREGA'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE MENSAL_PROX_DATA_ENTREGA
  GO

CREATE PROCEDURE MENSAL_PROX_DATA_ENTREGA
   @P_CDFILIAL     VARCHAR(4),
   @P_CDPERIENTR   VARCHAR(2),
   @P_DTINICIAL    DATETIME,
   @P_IDDIANUTIL   VARCHAR(1),
   @P_DTDIAENTR    DATETIME OUTPUT
AS
   DECLARE @V_CONTAUXI   NUMERIC(10);
   DECLARE @V_DIENTREGA  VARCHAR(2);
   DECLARE @V_DTULTDAT   DATETIME;

BEGIN
    SET @V_DIENTREGA = '00';
    SELECT @V_DIENTREGA = MIN(DIENTREGA)
    FROM DIASENTR
    WHERE
     CDPERIENTR = @P_CDPERIENTR;

    SET @V_DTULTDAT =  @P_DTINICIAL+1;
    EXEC ULTIMO_DIA_MES @P_DTDATA = @V_DTULTDAT OUTPUT;

    SET @P_DTDIAENTR = @P_DTINICIAL + CONVERT(INT,@V_DIENTREGA);
    IF (@P_DTDIAENTR > @V_DTULTDAT)
    BEGIN
        SET @P_DTDIAENTR = @V_DTULTDAT;
    END;

/*- CALCULA UMA DATA DE ENTREGA ANTERIOR A UMA DATA NAO UTIL -*/
    IF (@P_IDDIANUTIL = 'S')
    BEGIN
       SET @V_CONTAUXI = 1;
        WHILE (@V_CONTAUXI > 0)
        BEGIN
          SET @V_CONTAUXI = 0;
          SELECT @V_CONTAUXI = COUNT(*)
          FROM FERICOMP
          WHERE
          CDFILIAL = @P_CDFILIAL AND
          DTFERICOMP = @P_DTDIAENTR;
          IF @V_CONTAUXI > 0
          BEGIN
             SET @P_DTDIAENTR = @P_DTDIAENTR - 1;
          END;
        END;
    END;
    SET @P_DTDIAENTR = @P_DTDIAENTR - 1;
END;
GO