/* eslint-disable */
import { Utilities } from '@/util/Utilities';
import {
    CheckboxMultiple, ComponentRender, DateRange, DialogService, Form, LoadingService, Modal, ModalService, Select,
    SelectMultiple, TextInput, Time
} from '@zeedhi/common';
import { Http, IEventParam, Loader, Metadata } from '@zeedhi/core';
import { TekGrid, TekTreeGrid, } from '@zeedhi/teknisa-components-common';


export class Fm00004000TarefasController {
    private cadastroTarefaUnica!: Modal;

    private cadastroTarefaMassa!: Modal;

    private basicModalCriterio!: Modal;

    private modalConflitoDatas!: Modal;

    public hierarquiasController = Loader.getInstance('HierarquiasController');

    public visivel = true;

    public acessorVisivel = true;

    public operadorEditable: boolean = false;

    public horaInicio: boolean = false;

    public conflitoDatas: any = [];

    public bancoConflito: any = [];

    public title: String = "";

    public visibilidadeGridItens: boolean = false;

    public visibilidadeForm: boolean = true;

    public copy: any;

    public parametrizacao = "";

    public controleModalAberto = "";

    // ============Controle do modal==========
    // O modal cadastroTarefas  também é usado na tela "Calendário" pelo botão "Cadastrar Tarefa"
    public async exibirModalCadastroTarefas({ event }: any) {
        event.preventDefault();
        this.cadastroTarefaUnica = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00004_000_tarefas/modal/fm_00004_001_modal_cadastro_tarefas' });
        this.cadastroTarefaUnica.show();
        this.validaParametrizacao();
        this.controleModalAberto = "tarefaUnica";
    }

    public async fecharModalTarefas() {
        this.cadastroTarefaUnica.hide();
        this.cadastroTarefaUnica?.destroy();
        this.controleModalAberto = ""
    }

    public async exibirModalCadastroMassa({ event }: any) {
        event.preventDefault();
        this.cadastroTarefaMassa = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00004_000_tarefas/modal/fm_00004_005_modal_cadastro_tarefas_massa' });
        this.cadastroTarefaMassa.show();
        this.validaParametrizacao();
        this.controleModalAberto = "tarefaMassa";
    }

    public async fecharModalTarefasMassa() {
        this.cadastroTarefaMassa.hide();
        this.cadastroTarefaMassa?.destroy();
        this.controleModalAberto = ""
    }

    public async exibirModalCriterios() {
        this.basicModalCriterio = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00004_000_tarefas/modal/fm_00004_002_modal_cadastro_criterio' });
        this.basicModalCriterio.show();
    }

    public async fecharModalCriterio() {
        this.basicModalCriterio.hide();
        this.basicModalCriterio?.destroy();
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(`formTarefas_${component.name}`);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public async exibirModalConflitoDatas() {
        if (this.modalConflitoDatas) {
            await this.fecharModalConflitoDatas();
        }
        this.modalConflitoDatas = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00004_000_tarefas/modal/fm_00004_004_modal_conflito_datas' });
        this.modalConflitoDatas.show();
    }

    public async fecharModalConflitoDatas() {
        this.modalConflitoDatas.hide();
        this.modalConflitoDatas?.destroy();
        this.visibilidadeGridItens = false;
        this.visibilidadeForm = true;
    }

    // ==========Controles dos Selects ===================

    // INTEGRAÇÃO COM SM
    public changeContratos({ component }: any) {
        if ((this.controleModalAberto === "tarefaUnica")) {
            const selectContratos = Metadata.getInstance<Select>('NRSEQCONTRATO');
            if (component.value > 0) {
                selectContratos.disabled = false;
                const { selectValue } = component;
                selectContratos.datasource.setFilter({
                    NRESTRUTURAM: selectValue.NRESTRUTURAM,
                });
            } else if (component.value < 1) {
                selectContratos.disabled = true;
            }
        } else {
            this.defineTarefa();
            const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
            if (grid.editing) {
                Metadata.getInstance<Select>(component.name).datasource.setFilter({
                    NRESTRUTURAM: grid.datasource.currentRow.NRESTRUTURAM,
                });
            }
        }
    }

    public changeTipoDeLocal() {
        const cliente = Metadata.getInstance<Select>('CDCLIENTE');
        const tipoLocal = (this.controleModalAberto === "tarefaUnica") ? Metadata.getInstance<Select>('NRTIPOLOCALCLI') : Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        if (cliente.value) {
            tipoLocal.disabled = false;
        } else {
            tipoLocal.disabled = true;
        }
    }

    public changeLocal() {
        const tipoLocal = (this.controleModalAberto === "tarefaUnica") ? Metadata.getInstance<Select>('NRTIPOLOCALCLI') : Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const local = (this.controleModalAberto === "tarefaUnica") ? Metadata.getInstance<Select>('NRLOCALCLIENTE') : Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        if (this.controleModalAberto !== "tarefaUnica" && tipoLocal.value.length > 0 || this.controleModalAberto === "tarefaUnica" && tipoLocal.value > 0 ) {
            local.disabled = false;
            checklist.disabled = false;
            local.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: (this.controleModalAberto === "tarefaUnica") ? "S" : "N",
            });
            checklist.datasource.setFilter({
                NRTIPOLOCALCLI: tipoLocal.value,
                UNICA: (this.controleModalAberto === "tarefaUnica") ? "S" : "N",
            });
        } else {
            local.setValue([]);
            local.disabled = true;
            checklist.setValue(null);
            checklist.disabled = true;
        }
    }

    public changeItensChecklist() {
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK');
        if (checklist.value > 0 ) {
            itenschecklist.disabled = false;
            itenschecklist.datasource.setFilter({
                NRCHECKLIST: checklist.value,
            });
        } else {
            itenschecklist.setValue([]);
            itenschecklist.disabled = true;
        }
    }

    public changeEscopo() {
        const itenschecklist = Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI');
        const escopo = Metadata.getInstance<Select>('NRESCOPOSTAREFA');
        if (this.controleModalAberto !== "tarefaUnica" && itenschecklist.value.length > 0 || this.controleModalAberto === "tarefaUnica" && itenschecklist.value > 0 ) {
            escopo.disabled = false;
        } else {
            escopo.setValue([]);
            escopo.disabled = true;
        }
    }

    public changeTarefa() {
        const escopo = Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA');
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        if (escopo.value.length > 0) {
            tarefa.disabled = false;
            tarefa.datasource.setFilter({
                NRATIVIDADECHK: itenschecklist.value,
            });
        } else {
            tarefa.setValue([]);
            tarefa.disabled = true;
        }
    }

    public setCriterios() {
        const tarefa = Metadata.getInstance<SelectMultiple>('NRTAREFACHK');
        const itenschecklist = Metadata.getInstance<Select>('NRATIVIDADECHK');
        const checklist = Metadata.getInstance<Select>('NRCHECKLIST');
        const checkbox = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        if (tarefa.value.length > 0) {
            checkbox.datasource?.setFilter({
                NRTAREFACHK: tarefa.value,
                NRATIVIDADECHK: itenschecklist.value,
                NRCHECKLIST: checklist.value,
            });
            checkbox.datasource?.get();
            checkbox.isVisible = true;
        } else {
            tarefa.setValue([]);
            checkbox.isVisible = false;
        }
    }

    public novoCriterio() {
        const chk = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const valor = Metadata.getInstance<TextInput>('inputNovoCriterio').value;
        chk!.datasource!.data!.push({
            NRCRITERIOTAREFACHK: valor,
            DSCRITERIOTAREFA: valor,
        });
        chk!.value.push(valor);
        this.fecharModalCriterio();
    }

    public setFiltro({ component }: any) {
        component.datasource.dynamicFilter = {
            IDATIVO: [{
                relation: 'AND',
                operation: 'IN',
                value: 'S',
            }],
        };
        component.datasource.get();
    }

    public validaVistoria() {
        const vistoria = Metadata.getInstance<Select>('selectCriarVistoria');
        const observacao = Metadata.getInstance<Select>('selectObservacoesObrigatorias');
        if (vistoria.value == 1) {
            observacao!.datasource!.data!.push({
                value: '3',
                text: "Somente na vistoria",
            });
            observacao!.datasource!.data!.push({
                value: '4',
                text: "Na tarefa e na vistoria",
            });
        } else {
            observacao.datasource?.get();
        }
    }

    /* ================ Funções responsáveis para fazer a inserção das tarefas ===================================== */

    public validaDiaPeriodo(data: any, data2: any, dias: any) {
        for (let dataAux = data; data <= data2; dataAux.setDate(dataAux.getDate() + 1)) {
            if (dias.includes(String(dataAux.getDay()))) {
                return true;
            }
        }
        return false;
    }

    public validaInsercao() {
        const formTarefas = Metadata.getInstance<Form>('formCadastroTarefas').validate();
        const formCriterios = Metadata.getInstance<Form>('formTarefas_dropBoxCriterioAvaliacao').validate();
        const formAgendamento = Metadata.getInstance<Form>('formTarefas_dropBoxDadosAgendamento').validate();
        return (formTarefas && formCriterios && formAgendamento);
    }

    public executorHora() {
        let dados: any = [];
        if ((this.controleModalAberto === "tarefaUnica")) {
            dados.push({
                HORAINICIO: Metadata.getInstance<Time>('selectHoraInicio1').value,
                DURACAO: Metadata.getInstance<TextInput>('selectdDuracao1').value,
                FUNCIONARIO: Metadata.getInstance<Select>('selectFuncionario1').value,
                ENCARREGADO: Metadata.getInstance<Select>('selectEncarregado1').value,
                NRSEQCONTRATO: Metadata.getInstance<Select>('NRSEQCONTRATO').value,
                NRLOCALCLIENTE: Metadata.getInstance<Select>('NRLOCALCLIENTE').value
            });

        } else {
            const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
            grid.datasource.data.forEach(element => {
                dados.push({
                    HORAINICIO: element.HORAINICIO,
                    DURACAO: element.selectdDuracao1,
                    FUNCIONARIO: element.selectOperador,
                    ENCARREGADO: element.selectEncarregado1,
                    NRLOCALCLIENTE: element.NRLOCALCLIENTE,
                    NRSEQCONTRATO: element.NRSEQCONTRATO,
                });
            });
        }
        return dados;
    } 

    public inserirTarefa() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas');
        const checkBoxMultiple = Metadata.getInstance<CheckboxMultiple>('NRCRITERIOTAREFACHK');
        const diaSemana = Metadata.getInstance<SelectMultiple>('selectDiaSemana').value;
        const dataRange = Metadata.getInstance<DateRange>('selectData').value;
        if (this.validaDiaPeriodo(new Date(dataRange[0]), new Date(dataRange[1]), diaSemana)) {
            const dados = (this.bancoConflito.length > 0) ? this.bancoConflito : this.executorHora();
            LoadingService.show();
            Http.post('/insertNovaTarefa', {
                NOMETAREFA: Metadata.getInstance<TextInput>('nomeTarefa').value,
                CDCLIENTE: Metadata.getInstance<Select>('CDCLIENTE').value,
                NRTIPOLOCALCLI: Metadata.getInstance<SelectMultiple>('NRTIPOLOCALCLI').value,
                NRLOCALCLIENTE: Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').value,
                NRCHECKLIST: Metadata.getInstance<Select>('NRCHECKLIST').value,
                NRATIVIDADECHK: Metadata.getInstance<SelectMultiple>('NRATIVIDADECHK').value,
                NRESCOPOSTAREFA: Metadata.getInstance<SelectMultiple>('NRESCOPOSTAREFA').value,
                NRTAREFACHK: Metadata.getInstance<SelectMultiple>('NRTAREFACHK').value,
                NRCRITERIOTAREFACHK: checkBoxMultiple.datasource?.data.filter((box: any) => checkBoxMultiple.value.indexOf(box.NRCRITERIOTAREFACHK) >= 0),
                DATERANGE: dataRange,
                DIASEMANA: diaSemana,
                VISTORIA: Metadata.getInstance<Select>('selectCriarVistoria').value,
                OBSERVACOES: Metadata.getInstance<Select>('selectObservacoesObrigatorias').value,
                EXECUTORHORA: dados,
                SWITCHFUNCIONARIO: false,

            }).then(() => {
                Utilities.showSuccessMessage();
              ( this.controleModalAberto === 'tarefaUnica') ? this.fecharModalTarefas() : this.fecharModalTarefasMassa();
                grid.datasource.get();
            }).catch((error: any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        } else {
            DialogService.show({
                name: 'error_dialog',
                type: 'error',
                title: 'Erro',
                text: "O período selecionado não possui o(s) dia(s) da semana escolhido.",
            });
        }

    }
    /* ============================================================================================ */

    public excluirTarefas({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'Fm00004000TarefasController.aposConfirmarDelete', 'Excluir Registro?');
    }

    public aposConfirmarDelete() {
        const component = Metadata.getInstance<TekGrid>('tek-grid-tarefas');
        LoadingService.show();
        Http.post('/inativarTarefas', {
            NRS: component.selectedRows.map((element: any) => element.NRCHECKLISTAGEND),
        }).then(() => {
            component.datasource.get();
            Utilities.showSuccessMessage();
        }).catch((error: any) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            component.selectedRows = [];
            LoadingService.hide();
            DialogService.hide();
        });
    }

    // Recebe um intervalo de data/hora para ser comaprado com o grid afim de validar se há valores iguais.
    // dig == data inicial grid. dfg == data final grid
    // din == data inicial nova. dfn == data final nova
    public validaHorario(din: any, dfn: any, funcionario: any, encarregado: any, index: any, HORAINICIO: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-tarefas').datasource.data;
        grid.forEach(element => {
            const dig = Utilities.creatDate(element.DTHORAAGEND);
            const dfg = Utilities.creatDate(element.DTHRFINALAGEND);
            if (funcionario === element.CDOPERADOR) {
                if ((din.valueOf() >= dig.valueOf() && din.valueOf() <= dfg.valueOf()
                    || dfn.valueOf() >= dig.valueOf() && dfn.valueOf() <= dfg.valueOf()) ||
                    dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf()
                    || dig.valueOf() >= din.valueOf() && dig.valueOf() <= dfn.valueOf()) {
                    const teste = this.conflitoDatas.findIndex((elemento: any) => elemento.INDEX == index);
                    if (teste < 0) {
                        this.conflitoDatas.push({
                            INDEX: index,
                            DHINICIALNOVA: din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2),
                            DHFINALNOVA: dfn.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2),
                            INDEXPAI: null,
                            NMOPERADOR: element.NMOPERADOR,
                            CDOPERADOR: element.CDOPERADOR,
                            ENCARREGADO: encarregado,
                            HORAINICIO: HORAINICIO,
                            acoesSelect: 'Não',
                        });
                    }
                    this.conflitoDatas.push({
                        DHINICIALGRID: dig.toLocaleDateString('pt-br') + " " + ("00" + dig.getHours()).slice(-2) + ':' + ("00" + dig.getMinutes()).slice(-2),
                        DHFINALGRID: dfg.toLocaleDateString('pt-br') + " " + ("00" + dfg.getHours()).slice(-2) + ':' + ("00" + dfg.getMinutes()).slice(-2),
                        INDEX: `${index}${this.conflitoDatas.length}`,
                        INDEXPAI: index,
                        NRCHECKLISTAGEND: element.NRCHECKLISTAGEND,
                        NMCHECKLISTAGEND: element.NMCHECKLISTAGEND,
                    });
                }
            }
        });
    }

    public validaParametrizacao() {
        Http.get('getParametroConflito').then((response) => {
            this.parametrizacao = response.data[0]['IDVALIDACRIATAREFA'];
        });
    }

    // Pega as informações do form como data inicial, duração e funcionário. Formata para ser compatível com a data do Grid vinda do backEnd.
    public formatarDataHora(editedRow: any, revalidar: boolean) {
        if (this.conflitosHoraGrid.length != 0) {
            Utilities.alertMessage('Existem conflitos pendentes!', 'error');
        } else if (this.validaInsercao()) {
            let index = 1;
            const dataRange = Metadata.getInstance<DateRange>('selectData').value;
            const dataFormatada = this.formataData(dataRange);
            const diasSemana = Metadata.getInstance<SelectMultiple>('selectDiaSemana').value;
            if (revalidar == true) {
                const grid = Metadata.getInstance<TekTreeGrid>('tek-grid-nova-tarefa');
                const HORAINICIO = 0;
                editedRow.forEach((iteracoes: any) => {
                    let din = Utilities.creatDate(iteracoes.DHINICIALNOVA);
                    let dfn = Utilities.creatDate(iteracoes.DHFINALNOVA);
                    let CDOPERADOR = (iteracoes.NMOPERADOR.length == 12) ? iteracoes.NMOPERADOR : iteracoes.CDOPERADOR;
                    let duracao = ((dfn.valueOf() - din.valueOf()) / 1000 / 60);
                    const [hora, minuto] = iteracoes.HORAINICIO.split(':');
                    din.setHours(hora);
                    din.setMinutes(minuto);
                    dfn = new Date(din.valueOf());
                    dfn.setMinutes(dfn.getMinutes() + duracao);
                    this.validaHorario(din, dfn, CDOPERADOR, iteracoes.encarregado, iteracoes.INDEX, HORAINICIO);
                    this.fecharModalConflitoDatas();
                    //this.montaGrid();
                });
            } else {
                this.conflitoDatas = [];
                this.bancoConflito = [];
                this.executorHora().forEach((element: any) => {
                    let dataInicio = new Date(dataFormatada[0].valueOf());
                    for (dataInicio; dataInicio <= dataFormatada[1]; dataInicio.setDate(dataInicio.getDate() + 1)) {
                        if (diasSemana.includes(String(dataInicio.getDay()))) {
                            const din = new Date(dataInicio.valueOf());
                            const [hora, minuto] = element.HORAINICIO.split(':');
                            let HORAINICIO = element.HORAINICIO;
                            din.setHours(hora);
                            din.setMinutes(minuto);
                            const dfn = new Date(din.valueOf());
                            dfn.setMinutes(dfn.getMinutes() + (Math.trunc(element.DURACAO / 100) * 60) + (element.DURACAO % 100));
                            this.copy = JSON.parse(JSON.stringify(element));
                            this.copy['INDEX'] = index;
                            this.copy['DURACAO'] = ((dfn.valueOf() - din.valueOf()) / 1000 / 60)
                            this.copy['DATAFINAL'] = dfn.toLocaleDateString('pt-br') + " " + ("00" + dfn.getHours()).slice(-2) + ':' + ("00" + dfn.getMinutes()).slice(-2);
                            this.copy["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
                            this.copy["NRSEQCONTRATO"] = element.NRSEQCONTRATO;
                            this.bancoConflito.push(this.copy);
                            (this.parametrizacao == "N") ? this.validaHorario(din, dfn, element.FUNCIONARIO, element.ENCARREGADO, index, HORAINICIO) : "";
                            index++;
                        }
                    }
                });
            }

            this.title = Metadata.getInstance<TextInput>('nomeTarefa').value;
            revalidar = false;
            if (this.conflitoDatas.length > 0) {
                this.exibirModalConflitoDatas();
            } else {
                this.fecharModalTarefas();
                this.inserirTarefa();
            }
        }
    }

    public confirmaInsersao() {
        if (this.conflitoDatas.length > 0) {
            Utilities.alertMessage('Existem conflitos pendentes!', 'error');
        } else {
            this.fecharModalConflitoDatas();
            this.fecharModalTarefas();
            this.inserirTarefa();
        }
    }

    // Pega o dataRange da função formatarDataHora e converete para formato Date, retornando na linha 223.
    public formataData(dataRange: any) {
        const [mesInicial, diaInicial, anoInicial] = dataRange[0].split('/');
        const [mesFinal, diaFinal, anoFinal] = dataRange[1].split('/');
        return [new Date(anoInicial, mesInicial - 1, diaInicial), new Date(anoFinal, mesFinal - 1, diaFinal)]
    }

    public montaGrid() {
        const grid = Metadata.getInstance<TekTreeGrid>('tek-grid-nova-tarefa');
        const dadosPai = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI == null))
        dadosPai.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALNOVA: dados.DHINICIALNOVA,
                DHFINALNOVA: dados.DHFINALNOVA,
                NMOPERADOR: dados.NMOPERADOR,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                CDOPERADOR: dados.CDOPERADOR,
                HORAINICIO: dados.HORAINICIO,
                acoesSelect: dados.acoesSelect,
            });
        });
    }

    public montaGridConflito({ row }: any) {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-conflito-datas');
        grid.datasource.data = [];
        const dadosFilho = this.conflitoDatas.filter((dados: any) => (dados.INDEXPAI == row.INDEX))
        dadosFilho.forEach((dados: any) => {
            grid.datasource.data.push({
                DHINICIALGRID: dados.DHINICIALGRID,
                DHFINALGRID: dados.DHFINALGRID,
                NRCHECKLISTAGEND: dados.NRCHECKLISTAGEND,
                NMCHECKLISTAGEND: dados.NMCHECKLISTAGEND,
                INDEX: dados.INDEX,
                INDEXPAI: dados.INDEXPAI
            });
        });
        this.rowClickFiltroGrid();
    }

    public rowClickFiltroGrid() {
        this.visibilidadeGridItens = true;
        this.visibilidadeForm = !this.visibilidadeGridItens;
    }

    public verificarConflitos({ component }: IEventParam<TekGrid>) {
        if (Utilities.validateGrid(component)) {
            this.atualizaBancoConflitos(component.getEditedRows());
            const alteracoes: any = component.getEditedRows().filter((elemento: any) => elemento.acoesSelect != 1);
            const revalidar = true;
            this.conflitoDatas = [];
            this.formatarDataHora(alteracoes, revalidar);
        }
    }

    public atualizaBancoConflitos(dadosEditados: any) {
        dadosEditados.forEach((element: any) => {
            const dataInicio = Utilities.creatDate(element['DHINICIALNOVA']);
            const din = new Date(dataInicio.valueOf());
            const [hora, minuto] = element.HORAINICIO.split(':');
            din.setHours(hora);
            din.setMinutes(minuto);
            const pos = this.bancoConflito.findIndex((dados: any) => dados.INDEX == element.INDEX);
            this.bancoConflito[pos]["FUNCIONARIO"] = (element.NMOPERADOR.length == 12) ? element.NMOPERADOR : element.CDOPERADOR;
            this.bancoConflito[pos]["DATAINICIAL"] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("00" + din.getMinutes()).slice(-2);
            this.bancoConflito[pos]["IGNORAR"] = element.acoesSelect;
            this.bancoConflito[pos]['DATAFINAL'] = din.toLocaleDateString('pt-br') + " " + ("00" + din.getHours()).slice(-2) + ':' + ("0000" + String(this.bancoConflito[pos]['DURACAO'])).slice(-2);
        });
    }

    // --------------------- GRID DADOS AGENDAMENTOS ---------------------------
    public defineTarefa() {
        const grid = Metadata.getInstance<TekGrid>('tek-grid-dados-agendamento');
        grid.datasource.data = [];
        const NRLOCALCLIENTE = Metadata.getInstance<SelectMultiple>('NRLOCALCLIENTE').selectValue;
        NRLOCALCLIENTE.forEach((element: any) => {
            grid.datasource.data.push({
                NMLOCALCLIENTE: element.NMLOCALCLIENTE,
                NRLOCALCLIENTE: element.NRLOCALCLIENTE,
                NRESTRUTURAM: element.NRESTRUTURAM,
            });
        });
    }

    public baseDadosGrid: any = [];
    public pegaInformacoesGrid({ component }: any) {
        // const DATARANGE = this.formataData(Metadata.getInstance<DateRange>('selectData'));
        const BASEDADOS = component.getEditedRows();
        let index = 0;
        this.baseDadosGrid = [];
        BASEDADOS.forEach((element: any) => {
            let [hora, minuto] = element.HORAINICIO.split(':');
            let horaduracao = parseInt(element.selectdDuracao1.slice(0, 2));
            let minutoduracao = parseInt(element.selectdDuracao1.slice(2, 4));
            hora = parseInt(hora); minuto = parseInt(minuto);
            this.baseDadosGrid.push({
                HORAINICIO: (hora * 60) + minuto,
                HORAFINAL: (hora * 60) + minuto + (horaduracao * 60) + minutoduracao,
                OPERADOR: element.selectOperador,
                TAREFA: element.NMLOCALCLIENTE,
                INDEX: index++,
            });

        });
        this.conflitosHoraGrid = [];
        this.baseDadosGrid.forEach((element: any) => {
            this.verificaConflitosGrid(element.OPERADOR, element.HORAINICIO, element.HORAFINAL, element.INDEX, element.TAREFA);
        });

        if (this.conflitosHoraGrid.length != 0) {
            const nomesDasTarefasComConflito = (this.conflitosHoraGrid.map((elemento: any) => elemento.TAREFA).join(", "));
            DialogService.show({
                name: 'basic-dialog',
                title: 'Conflitos',
                text: `Existem conflitos de horários nos seguintes locais: <br><br>${nomesDasTarefasComConflito}`
            });
        }
    }

    public conflitosHoraGrid: any = [];
    public verificaConflitosGrid(Operador: any, HORAINICIO: any, HORAFINAL: any, INDEX: any, TAREFA: any) {

        this.baseDadosGrid.forEach((element: any) => {
            const HI = element.HORAINICIO;
            const HF = element.HORAFINAL
            if (element.OPERADOR === Operador && element.INDEX != INDEX) {
                if (HORAINICIO >= HI && HORAINICIO <= HF || HORAFINAL >= HI && HORAFINAL <= HF) {
                    this.conflitosHoraGrid.push({
                        INDEX: INDEX,
                        OPERADOR: element.OPERADOR,
                        TAREFA: TAREFA,
                        CONFLITO: element.TAREFA,
                    });
                }
            }
        });
    }

    public validaDuracao({ component }: any) {
        if (component.value != null && component.value.slice(2, 4) === "60") {
            let hora = parseInt(component.value.slice(0, 2));
            hora++;
            component.value = ("00" + hora.toString() + "00").slice(-4);
        }
    }
}

